/*
 * Copyright 2021 Chaos Mesh Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

import { DndProvider } from 'react-dnd'
import { HTML5Backend } from 'react-dnd-html5-backend'
import { Provider } from 'react-redux'
import { BrowserRouter as Router } from 'react-router-dom'
import ThemeProvider from './ThemeProvider'
import TopContainer from 'components/TopContainer'
import store from './store'

const App: React.FC = ({ children }) => (
  <Provider store={store}>
    <Router>
      <ThemeProvider>
        <DndProvider backend={HTML5Backend}>{children || <TopContainer />}</DndProvider>
      </ThemeProvider>
    </Router>
  </Provider>
)

export default App
